Uploaded image for project: 'Maven'
  1. Maven
  2. MNG-5197

locally declared test dependency's first-generation transitive dependency version incorrectly overrides (n > 1)th-generation compile-scoped dependency version

    XMLWordPrintableJSON

Details

    • Bug
    • Status: Reopened
    • Major
    • Resolution: Unresolved
    • 2.2.1, 3.0.3
    • Dependencies
    • None
    • OSX, Windows 7

    Description

      This bug seems to relate to MNG-4457, MNG-4156, and potentially others, but I have opened a new issue since nothing I found while searching could be described in precisely the same way.

      The test project I am attaching defines three modules:
      thing1
      thing2
      thing3

      thing1 depends on hamcrest-core 1.2
      thing2 depends on thing1 and junit 4.10
      thing3 depends on thing2 and junit 4.10

      If you install these, you can then view the dependency trees for thing2 and thing3 and see that thing1 correctly resolves v1.2 for hamcrest-core. thing3, however, apparently overrides the version back to 1.1, apparently accessed transitively via junit.

      Thanks to Mark Struberg for his help in isolating this behavior!

      Attachments

        1. test-versions.tar.gz
          2 kB
          Matthew Jason Benson

        Issue Links

          Activity

            People

              Unassigned Unassigned
              mbenson Matthew Jason Benson
              Votes:
              1 Vote for this issue
              Watchers:
              3 Start watching this issue

              Dates

                Created:
                Updated: